/////////////////////////////////////////////////////////////////////////////////
//
// countptr.cpp
//
//
/*
 * $Log: countptr.h,v $
 * Revision 1.2  2000/07/07 14:11:55  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 */

#pragma once
#pragma warning(disable : 4786)


///////////////////////////////////////////////////////////////////////////
//

template <class T>
class count_ptr {
    T* ptr_;
    unsigned* cnt_;
    void inc_ref(const count_ptr& r);
    void dec_ref();
public:
    explicit count_ptr(T* p = 0) : ptr_(p), cnt_(0)
        { if (p) cnt_ = new unsigned(1); }
    count_ptr(const count_ptr& r)
        { inc_ref(r); }
    ~count_ptr()
        { dec_ref(); }
    count_ptr& operator=(const count_ptr& r)
        { if (this != &r) { dec_ref(); inc_ref(r); } return *this; }
    T* operator=(T* p)
        { if (ptr_ == p) return p; dec_ref(); if (p) cnt_ = new unsigned(1); ptr_ = p; return p; }
    T& operator*() const
        { return *ptr_; }
    T* operator->() const
        { return ptr_; }
    T* get() const
        { return ptr_; }
    bool unique() const
        { return cnt_ ? *cnt_ == 1 : true; }
    bool operator<(const count_ptr& r)
        { return *ptr_ < *r; }
};

template <class T>
inline void count_ptr<T>::dec_ref() {
    if (cnt_) {
        if (--*cnt_ == 0) {
            delete cnt_;
            delete ptr_;
        }
        cnt_ = 0;
        ptr_ = 0;
    }
}

template <class T>
inline void count_ptr<T>::inc_ref(const count_ptr<T>& r) {
    ptr_ = r.ptr_;
    cnt_ = r.cnt_;
    if (cnt_)
        ++*cnt_;
}

///////////////////////////////////////////////////////////////////////////
//

template <class T>
class RCPtr
{
public:
    RCPtr(T* realPtr = 0)
        { pointee = realPtr; init(); }
    RCPtr(const RCPtr& rhs);
    ~RCPtr()
        { if (pointee) pointee->removeReference(); }
    RCPtr& operator=(const RCPtr& rhs);
    bool operator==(const RCPtr& rhs)
        { return (pointee == rhs.pointee); }
    bool operator!=(const RCPtr& rhs)
        { return (pointee != rhs.pointee); }
    T* operator->() const
        { return pointee; }
    T& operator*() const
        { return *pointee; }
private:
    void init();

    T* pointee;
};

template<class T>
void RCPtr<T>::init()
{
    if (pointee == 0)
        return;
    if (pointee->isShareable() == false)
        pointee = new T(*pointee);
    pointee->addReference();
}

template<class T>
RCPtr<T>& RCPtr<T>::operator=(const RCPtr& rhs)
{
    if (pointee != rhs.pointee)
    {
        if (pointee)
            pointee->removeReference();
        pointee = rhs.pointee;
        init();
    }
    return *this;
}



class RCObject
{
public:
    void addReference()
        { ++refCount; }
    void removeReference()
        { if (--refCount == 0) delete this; }
    void markUnshareable()
        { shareable = false; }
    bool isShareable() const
        { return shareable; }
    bool isShared() const
        { return refCount > 1; }
protected:
    RCObject() { refCount = 0; shareable = true; }
    RCObject(const RCObject& rhs) { refCount = 0; shareable = true; }
    RCObject& operator=(const RCObject& rhs) { return *this; }
    virtual ~ RCObject() {}
private:
    int refCount;
    bool shareable;
};

